{Cislo 11}

program Safety_matches;

uses
  crt, graph;

const
  _MaxN = 21;   {Maximalni velikost pole}
  _MinN = 2;    {Minimalni -||-}
  _BX   = 20;   {Sirka jednoho policka}
  _BY   = 20;   {Vyska -||-}
  _StartX = 20;
  _StartY = 20;

  _ClNic = 8;
  _MaxVTopTen = 21;

var
  Gd, Gm         : Integer;
  N              : Byte;     {Sirka pole}
  ErrCode        : Integer;
  KonecProgramu  : Boolean;  {Kdyz je true tak muze skoncit program}
  Key            : Char;     {Zmacknuta klavesa}

  XPole, YPole   : Array [1.._MaxN, 1.._MaxN] Of Byte;
  XMouse, YMouse : Word;
  Button         : Word;

  AktX, AktY     : Word;
  PosType        : Byte;

  SkoreHrace1    : Word;
  SkoreHrace2    : Word;
  HrajeHrac      : Byte; {Jaky hraje hrac}

  PomProm1, PomProm2 : Word;
  PomProm3           : Word;

  Polozil        : Boolean; {Jestli polozil sirku}
  PomS           : String;

  Jmeno  : Array[1.._MaxVTopTen] of String;
  Skore  : Array[1.._MaxVTopTen] of Word;
  Vyhral : Byte;

procedure refresh; {Prekresli obrazovku}
var
  i, j : word; {Pocitadla}
  PS   : String;

begin

  SetColor(4);

  For I := 1 to N - 1 do
   For J := 1 to N - 1 do
   begin

     If (XPole[I, J] = 0) then SetColor(_ClNic) else SetColor(6);

     Line(_StartX + I * _BX      , _StartY + J * _BY,
          _StartX + I * _BX + _BX, _STartY + J * _BY);

     If (YPole[I, J] = 0) then SetColor(_ClNic) else SetColor(6);

     Line(_StartX + I * _BX , _StartY + J * _BY,
          _StartX + I * _BX , _STartY + J * _BY + _By);
   end;

   Inc(J);
   For i := 1 to N - 1do
   begin
     If (XPole[I, J] = 0) then SetColor(_ClNic) else SetColor(6);
     Line(_StartX + I * _BX      , _StartY + J * _BY,
          _StartX + I * _BX + _BX, _STartY + J * _BY);

     If (YPole[J, I] = 0) then SetColor(_ClNic) else SetColor(6);
     Line(_StartX + J * _BX , _StartY + I * _BY,
          _StartX + J * _BX , _STartY + I * _BY + _BY);
   end;

      if (PosType = 1) then
      begin
        SetColor(4 + XPole[AktX, AktY]);
        Line(_StartX + AktX * _BX      , _StartY + AktY * _BY,
             _StartX + AktX * _BX + _BX, _StartY + AktY * _BY)
      end
      else
      begin
        SetColor(4 + YPole[AktX, AktY]);
        Line(_StartX + AktX * _BX      , _StartY + AktY * _BY,
             _StartX + AktX * _BX      , _StartY + AktY * _BY + _BY);
      end;

  SetColor(4);
  SetFillStyle(1, 0);
  Bar(560, 30, 580, 40);
  Bar(560, 70, 580, 80);

  Line(480, 0, 480, GetMaxY - 1);

  OutTextXY(490, 10, 'Hrac cislo 1 : ');
  Str(SkoreHrace1, PS);
  OutTextXY(500, 30, 'Skore : ' + PS);

  OutTextXY(490, 50, 'Hrac cislo 2 : ');
  Str(SkoreHrace2, PS);
  OutTextXY(500, 70, 'Skore : ' + PS);

  Str(Hrajehrac, PS);
  SetColor(13);
  OutTextXY(490, 100, 'Hraje hrac cislo ' + PS);

end;

procedure Help;
begin
  ClearViewPort;

  SetColor(15);

  OutTextXY(150, 10, 'HELP');
  OutTextXY(100, 50, '"4", "5", "6", "8" - Pohyb po poly');
  OutTextXY(100, 80, 'Space - Zmeneni natoceni sirky');
  OutTextXY(100, 100, 'Enter a myska - Polozeni sirky');
  OutTextXY(100, 120,  '"h" - Vyvola help');
  OutTextXY(100, 140, '"l" - Vykresli listinu vitezu');
  OutTextXY(100, 160, '"n" - Napoveda od pocitace');
  ReadKey;

  ClearViewPort;

  Refresh;
end;

procedure Konec;
begin
  Halt(255);
end;

procedure Atributy;
var
  PS : String;

begin
  ClrScr;
  Write('Zadejte delku strany [2..20] : ');
  ReadLn(Ps);
  Val(Ps, N, ErrCode);
  If (ErrCode <> 0) or (N < _MinN) or (N > _MaxN) then
  begin
    TextColor(4);
    WriteLn('Spatne zadano.');
    TextColor(7);
    ReadKey;
    Konec;
  end;

  Inc(N);

end;

procedure InitMouse; assembler; {Zobrazi mysku}
asm
  mov al, 01h
  int 33h
end;

procedure CloseMouse; assembler;        {Skryje mysku}
asm
  mov al, 02h
  int 33h
end;

procedure CtiStav(var x, y, But : word);        {Vrati x, y mysky a zmacknuty tlacitko}
var
  xx, yy, butt : word;

begin
  asm
    mov ax, 03h
    int 33h
    mov xx, cx
    mov yy, dx
    mov butt, bx
  end;

  x   := xx;
  y   := yy;
  But := Butt;
end;

procedure VynulujPole;
var
  i, j : Word; {Pocitadla}

begin
  for I := 1 to N do
   for j := 1 to N Do
   begin
     XPole[I, J] := 0;
     YPole[I, J] := 0;
   end;
end;

procedure RanPole;
var
  i, j : word;

begin
  for i := 1 to n do
   for j := 1 to n do
   begin
     XPole[i, j] := Random(2);
     YPole[i, j] := Random(2);
   end;
end;

Procedure NextTurn;
Var
  Ps : String;

begin
  Str(HrajeHrac, Ps);

  SetColor(8);
  SetFillStyle(2, 8);
  Bar(100, 100, 500, 200);
  SetFillStyle(1, 7);
  Bar(120, 120, 480, 180);
  OuttextXY(130, 130, 'Hraje hrac ' + PS);
  ReadKey;
  ClearViewPort;
  Refresh;
end;

Procedure PolozitSirku;
begin
  Polozil := False;

  if (PosType = 1) Then
  begin
    If (XPole[AktX, AktY] = 0) then
    begin
      XPole[AktX, AKtY] := 1;
      Polozil := True;
    end;
  end;

  if (PosType = 2) Then
  begin
    If (YPole[AktX, AktY] = 0) then
    begin
      YPole[AktX, AKtY] := 1;
      Polozil := True;
    end;
  end;

  If Polozil then
  begin
    PomProm1 := XPole[AktX, AktY] + XPole[AktX, AktY + 1] + YPole[AktX, AktY] + YPole[AKtX + 1,  AktY];
    Case PosType of
      1 : PomProm2 := XPole[AktX, AktY] + XPole[AktX, AktY - 1] + YPole[AktX + 1, AktY - 1] + YPole[AKtX, AktY - 1];
      2 : PomProm2 := XPole[AktX - 1, AktY] + XPole[AktX - 1, AktY + 1] + YPole[AktX, AktY] + YPole[AKtX - 1, AktY];
    end;

    if (PomProm1 = 4) or (PomProm2 = 4) then
    begin
      if (PomProm1 = 4) Xor (PomProm2 = 4) then
      begin
        if hrajehrac = 1 then Inc(SkoreHrace1);
        if hrajehrac = 2 then Inc(SkoreHrace2);
        Refresh;
      end;
      if (PomProm1 = 4) And (PomProm2 = 4) then
      begin
        if hrajehrac = 1 then SkoreHrace1 := SkoreHrace1 + 2;
        if hrajehrac = 2 then SkoreHrace2 := SKoreHrace2 + 2;
        Refresh;
      end;
    end
    else
    begin
      If (HrajeHrac = 1) then HrajeHrac := 2 else HrajeHrac := 1;
      NextTurn;
    end;
  end;
end;

Procedure ListinaVitezu; {Zobrazi listinu vitezu}
var
  i, j : word;
  unt : text;
  ps : String;

begin
  SetFillStyle(2, red);
  Bar(100, 0, 540, GetmaxY - 1);
  SetFillStyle(1, 8);
  Bar(120, 20, 520, GetMaxX - 21);


  Assign(Unt, 'Listina.txt');
  {$I+}reset(Unt);{$I-}
  If IOResult <> 0 then
  begin
    Rewrite(Unt);
    Konec;
  end;

  I := 0;
  While (not eof(unt)) and (I < _MaxVTopTen) do
  begin
    inc(I);
    ReadLn(Unt, Skore[i], Jmeno[i]);

    Str(Skore[i], Ps);
    OutTextXY(130, 30 + I * 10, Jmeno[i] + ' ' + Ps);
  end;

  Close(Unt);
end;

procedure Ukonceni;
Var
  Unt    : Text;
  I, J   : word;
  Ps     : String;
  Jmenko : String;
  Jo     : Boolean;

begin
  ClearViewPort;

  SetColor(White);

  SetFillStyle(2, red);
  Bar(100, 100, 500, 200);
  SetFillStyle(1, 8);
  Bar(120, 120, 480, 180);

  If (SKoreHrace1 > SkoreHrace2) then begin
                                        OutTextXY(160, 140, 'Vyhral hrac cislo 1 : ');
                                        Vyhral := 1;
                                      end;
  If (SKoreHrace2 > SkoreHrace1) then begin
                                        OutTextXY(160, 140, 'Vyhral hrac cislo 2 : ');
                                        Vyhral := 2;
                                      end;
  If (SKoreHrace1 = SkoreHrace2) then OutTextXY(160, 140, 'Nikdo nevyhral.');

  ReadKey;

  ListinaVitezu;
  ReadKey;

  SetFillStyle(1, 0);
  Bar(100, 100, 540, 200);
  OutTextXY(150, 150, 'Zadejte sve jmeno.');
  ReadLn(Jmenko);

  Jo := False;

  Assign(Unt, 'Listina.txt');
  Rewrite(Unt);
  For I := 1 to 10 do
  begin
    if (Vyhral = 1) then
    begin
      If (SkoreHrace1 >= Skore[i]) and (Jo = False) then
      begin
        WriteLn(Unt, SkoreHrace1, ' ' + Jmenko);
        Jo := True;
      end;
    end;
    if (Vyhral = 2) then
    begin
      If (SkoreHrace2 >= Skore[i]) and (Jo = False) then
      begin
        WriteLn(Unt, SkoreHrace2, ' ' + Jmenko);
        Jo := True;
      end;
    end;
    WriteLn(Unt, Skore[i], Jmeno[i]);
  end;

  Close(Unt);

end;

procedure napoveda;   {Napoveda od pocitace {moc bych na to nevsazel}
var
  i, j   : word;
  ZX, ZY, ZZ : Word;

begin
  ZZ := 0;

  for i := 1 to N - 1 do
   for j := 1 to N - 1 do
   begin

     PomProm1 := XPole[i, j] + XPole[i, j + 1] + YPole[i, j] + YPole[i + 1,  j];

     If PomProm1 = 4 then
     begin
       zx := i;
       zy := j;
       zz := 1;
     end;

   end;

   if zz = 1 then
   begin
    AKtX := ZX;
    AKtY := ZY;
   end
   else
   begin
     aktX := Random(N-1) + 1;
     aktY := Random(N-1) + 1;
     PosType := Random(2) + 1;
   end;
  PolozitSirku;
end;


begin
  Atributy;     {Zadani velikosti pole}
  Randomize;

  DetectGraph(Gd, Gm);
  InitGraph(Gd, Gm, '');

  ErrCode := GraphResult;
  If ErrCode = GrOK then        {Kdyz se  podarilo nastavit gr. mod}
   begin
     InitMouse;
     VynulujPole; {Vynuluju obsah pole}

     Help;

     HrajeHrac := 1;
     AktX := 1;
     AktY := 1;
     PosType := 1;
     Refresh; {Prekresli obrazovku}

     NextTurn;

    Repeat

      CtiStav(XMouse, YMouse, Button);
{     PutPixel(Xmouse - 20, YMouse, 40);}
{      SetColor(4);
      Case PosType of
        1 : Line(XMouse - _BX div 2, YMouse - 2, XMouse + _BX div 2, YMouse - 2);
        2 : Line(XMouse - 2, YMouse - _BY div 2, XMouse - 2, YMouse + _BY div 2);
      end;}


      Refresh;
      Case PosType of
        1 : begin
            if ((XMouse > _StartX + _BX) and (XMouse < _StartX + (N) * _BX)) and
               ((YMouse > _StartY + _BY) and (YMouse < _StartY + (N + 1) * _BY)) then
              Line(XMouse div _BX * _BX       , YMouse div _By * _By,
                   XMouse div _BX * _BX + _BX , YMouse div _By * _By      );
            end;
        2 : begin
              if ((XMouse > _StartX + _BX) and (XMouse < _StartX + (N + 1) * _BX)) and
                 ((YMouse > _StartY + _BY) and (YMouse < _StartY + (N) * _BY)) then
              Line(XMouse div _BX * _BX       , YMouse div _By * _By,
                   XMouse div _BX * _BX       , YMouse div _By * _By + _BY);
            end;
      end;

      If (Button = 1) then
      begin
       if postype = 1 then
         if ((XMouse > _StartX + _BX) and (XMouse < _StartX + N * _BX )) and
            ((YMouse > _StartY + _BY) and (YMouse < _StartY + N * _BY + _BY)) then
      begin
        AktX := (Xmouse - _StartX) div _BX;
        AktY := (YMouse - _StartY) div _BY;

        PolozitSirku;
        Refresh;
      end;

       if postype = 2 then
         if ((XMouse > _StartX + _BX) and (XMouse < _StartX + N * _BX + _BX)) and
            ((YMouse > _StartY + _BY) and (YMouse < _StartY + N * _BY )) then
        begin
          AktX := (Xmouse - _StartX) div _BX;
          AktY := (YMouse - _StartY) div _BY;

          PolozitSirku;
          Refresh;
        end;
      end;

      Key := #0;
      if KeyPressed then
      begin
        key := UpCase(ReadKey);

        Case Key Of
          #27 : begin
                  KonecProgramu := True;
                End;
          ' ' : begin
                  If (PosType = 1) then
                  begin
                    PosType := 2;
                    If (AktY = N) then Dec(AktY);
                  end
                    else
                  begin
                    PosType := 1;
                    If (aktX = N) then Dec(AktX);
                  end;

                  Refresh;
                end;
          '4' : begin
                  Case PosType of
                    1 : if (AktX > 1) then Dec(AktX);
                    2 : if (AktX > 1) then Dec(AktX);
                  end;
                  Refresh;
                end;
          '6' : begin
                  case PosType of
                    1 : if (AktX < N - 1) then Inc(AktX);
                    2 : if (AktX < N) then Inc(AktX);
                  end;
                  Refresh;
                end;
          '8' : begin
                  Case PosType of
                    1 : If (AktY > 1) then Dec(AktY);
                    2 : If (AktY > 1) then Dec(AktY);
                  end;
                  Refresh;
                end;
          '5' : begin
                  Case PosType of
                    1 : If (AktY < N) then Inc(AktY);
                    2 : If (AktY < N - 1) then Inc(AktY);
                  end;
                  Refresh;
                end;
          #13 : begin
                  PolozitSirku;
                end;
        'H' : begin
                Help;
                ReadKey;
                ClearViewPort;
                Refresh;
              end;
        'L' : begin
                ClearViewPort;
                ListinaVitezu;
                ReadKey;
                KonecProgramu := True;
              end;
        'N' : begin
                Napoveda;
              end;
        end;
      end;

    Until (KonecProgramu = True) Or (SkoreHrace1 + SkoreHrace2 = sqr(N - 1));

    If (SkoreHrace1 + SkoreHrace2 = sqr(N - 1)) then
    begin
      Ukonceni;
    end;


    CloseMouse;
    CloseGraph;
   end
  else
   begin
     TextColor(4);
     Write('Nepodaril se nastavit graficky mod.');
     TextColor(7);
     ReadKey;
     Konec;
   end;
end.